SystemOrganization addCategory: #ConfigurationOfCoral!

Object subclass: #ConfigurationOfCoral
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfCoral'!

!ConfigurationOfCoral commentStamp: 'DamienPollet 8/13/2011 01:44' prior: 0!
Coral makes it possible to write shell scripts with Pharo.

Recommended loading:
	ConfigurationOfCoral load.             "as a user"
	ConfigurationOfCoral loadBleedingEdge. "as a contributor"
	

Development workflow	scripts

	MetacelloToolBox
		createDevelopment: '0.1'
		for: 'ConfigurationOfCoral'
		importFromBaseline: '0.1-baseline'
		description: 'Initial development version'.

	MetacelloToolBox validateConfiguration: ConfigurationOfCoral.

	Gofer new squeaksource: 'Coral';
		package: 'ConfigurationOfCoral';
		package: 'Coral-Core';
		package: 'Coral-Commandline';
		package: 'Coral-Tests';
		package: 'Coral-Utilities';
		commit: 'Reorganize packages, rewrite ConfigurationOfCoral from scratch.'
!

!ConfigurationOfCoral class methodsFor: 'development support' stamp: 'DamienPollet 8/13/2011 01:12'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfCoral class methodsFor: 'private' stamp: 'DamienPollet 8/13/2011 01:12'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfCoral class methodsFor: 'development support' stamp: 'DamienPollet 10/25/2011 17:31'!
createNewBaselineVersion
	"Create a new baseline version based upon the #stable version's baseline.
	 A new baseline should be created if new packages have been added or package dependencies have changed."

	"self createNewBaselineVersion"

	<apiDocumentation>
	self ensureMetacello.
	(Smalltalk at: #MetacelloToolBox) createNewBaselineVersionIn: self description: ''
! !

!ConfigurationOfCoral class methodsFor: 'development support' stamp: 'DamienPollet 10/6/2011 16:19'!
createNewDevelopmentVersion
	"Create a new development version using the #stable version as model."

	"self createNewDevelopmentVersion"

	<apiDocumentation>
	self ensureMetacello.
	(Smalltalk at: #MetacelloToolBox) createNewDevelopmentVersionIn: self description: ''! !

!ConfigurationOfCoral class methodsFor: 'private' stamp: 'DamienPollet 8/13/2011 01:12'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfCoral class methodsFor: 'private' stamp: 'DamienPollet 8/13/2011 01:12'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfCoral class methodsFor: 'metacello tool support' stamp: 'DamienPollet 8/13/2011 01:12'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfCoral class methodsFor: 'loading' stamp: 'DamienPollet 8/13/2011 01:12'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfCoral class methodsFor: 'loading' stamp: 'DamienPollet 8/13/2011 03:02'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfCoral class methodsFor: 'loading' stamp: 'DamienPollet 8/13/2011 03:02'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfCoral class methodsFor: 'accessing' stamp: 'DamienPollet 8/13/2011 01:12'!
project

	^self new project! !

!ConfigurationOfCoral class methodsFor: 'development support' stamp: 'DamienPollet 10/5/2011 19:03'!
saveConfiguration: commitMessage
	"Save mcz file that contains the configuration to it's repository."

	"self saveConfiguration: '- fixed bug'"

	<apiDocumentation>
	self ensureMetacello.
	(Smalltalk at: #MetacelloToolBox) saveConfigurationPackageFor: self name asString description: commitMessage! !

!ConfigurationOfCoral class methodsFor: 'development support' stamp: 'DamienPollet 10/6/2011 17:09'!
saveModifiedPackagesAndConfiguration: commitMessage
	"Save modified mcz files, update the #development version and then save the configuration."

	"self saveModifiedPackagesAndConfiguration: '- fixed bug'"

	<apiDocumentation>
	self ensureMetacello.
	(Smalltalk at: #MetacelloToolBox) saveModifiedPackagesAndConfigurationIn: self description: commitMessage! !

!ConfigurationOfCoral class methodsFor: 'development support' stamp: 'DamienPollet 10/5/2011 19:03'!
updateToLatestPackageVersions: descriptionString
	"Update the #development version to match currently loaded mcz files."

	"self updateToLatestPackageVersions: '- fixed a bug'"

	<apiDocumentation>
	self ensureMetacello.
	((Smalltalk at: #MetacelloToolBox) updateToLatestPackageVersionsIn: self description: descriptionString) isEmpty
		ifTrue: [ self inform: 'All specs up to date' ]! !

!ConfigurationOfCoral class methodsFor: 'development support' stamp: 'DamienPollet 8/13/2011 01:12'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfCoral methodsFor: 'baselines' stamp: 'DamienPollet 8/13/2011 03:01'!
baseline01: spec
	<version: '0.1-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://www.squeaksource.com/Coral'.
		
		spec
			project: 'Filesystem' with: [
				spec
					className: 'ConfigurationOfFilesystem';
					versionString: #bleedingEdge;
					repository: 'http://www.squeaksource.com/fs' ];
			project: 'OSProcess' with: [
				spec
					className: 'ConfigurationOfOSProcess';
					versionString: #stable;
					repository: 'http://www.squeaksource.com/MetacelloRepository' ];
			project: 'PetitParser' with: [
				spec
					className: 'ConfigurationOfPetitParser';
					versionString: #bleedingEdge;
					loads: #('Core' 'Tests' 'PetitSmalltalk');
					repository: 'http://source.lukas-renggli.ch/petit' ].

		spec
			package: 'Coral-Core' with: [
				spec requires: #('PetitParser' 'OSProcess') ];
			package: 'Coral-Utilities' with: [
				spec requires: #('Filesystem' 'OSProcess') ];
			package: 'Coral-Commandline' with: [
				spec requires: #('PetitParser') ];
			package: 'Coral-Tests' with: [
				spec requires: #('Coral-Core' 'Coral-Commandline') ].
		
		spec
			group: 'default' with: #('Coral-Core' 'Coral-Utilities' 'Coral-Commandline' 'Coral-Tests') ]
! !

!ConfigurationOfCoral methodsFor: 'baselines' stamp: 'DamienPollet 10/5/2011 17:06'!
baseline02: spec
	<version: '0.2-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec description: 'Move to Squeaksource3 and declare new packages'.
		spec repository: 'http://ss3.gemstone.com/ss/coral'.
		
		spec
			project: 'Filesystem' with: [
				spec
					className: 'ConfigurationOfFilesystem';
					versionString: #development;
					repository: 'http://www.squeaksource.com/fs' ];
			project: 'OSProcess' with: [
				spec
					className: 'ConfigurationOfOSProcess';
					versionString: #stable;
					repository: 'http://www.squeaksource.com/MetacelloRepository' ];
			project: 'PetitParser' with: [
				spec
					className: 'ConfigurationOfPetitParser';
					versionString: #development;
					loads: #('Core' 'Tests' 'PetitSmalltalk');
					repository: 'http://source.lukas-renggli.ch/petit' ].

		spec
			package: 'Coral-Core'					with: [ spec requires: #('PetitParser' 'OSProcess') ];
			package: 'Coral-Utilities'				with: [ spec requires: #('Filesystem' 'OSProcess') ];
			package: 'Coral-IO'						with: [ spec requires: #('OSProcess') ];
			package: 'Coral-Commandline'			with: [ spec requires: #('PetitParser') ];
			package: 'Coral-Tests' 					with: [ spec requires: #('Coral-Core' 'Coral-Commandline') ];
			package: 'Coral-Examples-Esug2011'	with: [ spec requires: #('Coral-Core' 'Coral-Commandline' 'OSProcess') ].
		
		spec
			group: 'default' with: #('Coral-Core' 'Coral-Utilities' 'Coral-IO' 'Coral-Commandline' 'Coral-Tests' 'Coral-Examples-Esug2011') ]
! !

!ConfigurationOfCoral methodsFor: 'baselines' stamp: 'DamienPollet 10/5/2011 17:44'!
baseline03: spec
	<version: '0.3-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec description: 'Move to Squeaksource3 and declare new packages'.
		spec repository: 'http://ss3.gemstone.com/ss/coral'.
		
		spec
			"project: 'Filesystem' with: [
				spec
					className: 'ConfigurationOfFilesystem';
					versionString: #development;
					repository: 'http://www.squeaksource.com/fs' ];"
			project: 'OSProcess' with: [
				spec
					className: 'ConfigurationOfOSProcess';
					versionString: #stable;
					repository: 'http://www.squeaksource.com/MetacelloRepository' ];
			project: 'PetitParser' with: [
				spec
					className: 'ConfigurationOfPetitParser';
					versionString: #development;
					loads: #('Core' 'Tests' 'PetitSmalltalk');
					repository: 'http://source.lukas-renggli.ch/petit' ].

		spec
			package: 'Coral-Core'					with: [ spec requires: #('PetitParser' 'OSProcess') ];
			package: 'Coral-Utilities'				with: [ spec requires: #('OSProcess') ];
			package: 'Coral-IO'						with: [ spec requires: #('OSProcess') ];
			package: 'Coral-Commandline'			with: [ spec requires: #('PetitParser') ];
			package: 'Coral-Tests' 					with: [ spec requires: #('Coral-Core' 'Coral-Commandline') ];
			package: 'Coral-Examples-Esug2011'	with: [ spec requires: #('Coral-Core' 'Coral-Commandline' 'OSProcess') ].
		
		spec
			group: 'default' with: #('Coral-Core' 'Coral-Utilities' 'Coral-IO' 'Coral-Commandline' 'Coral-Tests' 'Coral-Examples-Esug2011') ]
! !

!ConfigurationOfCoral methodsFor: 'baselines' stamp: 'DamienPollet 10/6/2011 20:22'!
baseline04: spec
	<version: '0.4-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec description: 'Add readline dependency'.
		spec repository: 'http://ss3.gemstone.com/ss/coral'.
		
		spec
			project: 'OSProcess' with: [
				spec
					className: 'ConfigurationOfOSProcess';
					versionString: #stable;
					repository: 'http://www.squeaksource.com/MetacelloRepository' ];
			project: 'PetitParser' with: [
				spec
					className: 'ConfigurationOfPetitParser';
					versionString: #development;
					loads: #('Core' 'Tests' 'PetitSmalltalk');
					repository: 'http://source.lukas-renggli.ch/petit' ];
			project: 'Readline' with: [
				spec
					className: 'ConfigurationOfReadline';
					versionString: #development;
					repository: 'http://ss3.gemstone.com/ss/readline' ].

		spec
			package: 'Coral-Core'					with: [ spec requires: #('PetitParser' 'OSProcess') ];
			package: 'Coral-Utilities'				with: [ spec requires: #('OSProcess') ];
			package: 'Coral-Commandline'			with: [ spec requires: #('PetitParser' 'Readline') ];
			package: 'Coral-Tests' 					with: [ spec requires: #('Coral-Core' 'Coral-Commandline') ];
			package: 'Coral-Examples-Esug2011'	with: [ spec requires: #('Coral-Core' 'Coral-Commandline' 'OSProcess') ].
		
		spec
			group: 'default' with: #('Coral-Core' 'Coral-Utilities' 'Coral-Commandline' 'Coral-Tests' 'Coral-Examples-Esug2011') ]
! !

!ConfigurationOfCoral methodsFor: 'baselines' stamp: 'DamienPollet 12/21/2011 17:09'!
baseline05: spec
	<version: '0.5-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec description: 'Use Coral-specific configuration of OSProcess'.
		spec repository: 'http://ss3.gemstone.com/ss/coral'.
		
		spec
			project: 'OSProcess' with: [
				spec
					className: 'ConfigurationOfOSProcess';
					versionString: #development;
					repository: 'http://ss3.gemstone.com/ss/coral' ];
			project: 'PetitParser' with: [
				spec
					className: 'ConfigurationOfPetitParser';
					versionString: #development;
					loads: #('Core' 'Tests' 'PetitSmalltalk');
					repository: 'http://ss3.gemstone.com/ss/coral' ];
			project: 'Readline' with: [
				spec
					className: 'ConfigurationOfReadline';
					versionString: #development;
					repository: 'http://ss3.gemstone.com/ss/readline' ].

		spec
			package: 'Coral-Core'					with: [ spec requires: #('PetitParser' 'OSProcess') ];
			package: 'Coral-Utilities'				with: [ spec requires: #('OSProcess') ];
			package: 'Coral-Commandline'			with: [ spec requires: #('PetitParser' 'Readline') ];
			package: 'Coral-Tests' 					with: [ spec requires: #('Coral-Core' 'Coral-Commandline') ];
			package: 'Coral-Examples-Esug2011'	with: [ spec requires: #('Coral-Core' 'Coral-Commandline' 'OSProcess') ].
		
		spec
			group: 'default' with: #('Coral-Core' 'Coral-Utilities' 'Coral-Commandline' 'Coral-Tests' 'Coral-Examples-Esug2011') ]
! !

!ConfigurationOfCoral methodsFor: 'symbolic versions' stamp: 'DamienPollet 10/6/2011 16:29'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '0.2'.
! !

!ConfigurationOfCoral methodsFor: 'accessing' stamp: 'DamienPollet 8/13/2011 01:12'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfCoral methodsFor: 'symbolic versions' stamp: 'DamienPollet 10/6/2011 16:21'!
stable: spec
	<symbolicVersion: #'stable'>

	spec for: #'common' version: #'notDefined'
! !

!ConfigurationOfCoral methodsFor: 'versions' stamp: 'DamienPollet 10/5/2011 19:03'!
version01: spec
	<version: '0.1' imports: #('0.3-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: 'Initial development snapshot'.
		spec author: 'DamienPollet'.
		spec timestamp: '10/5/2011 19:03'.
		spec 
			project: 'OSProcess' with: '4.4.5';
			project: 'PetitParser' with: '1.4'.
		spec 
			package: 'Coral-Core' with: 'Coral-Core-CamilloBruni.8';
			package: 'Coral-Utilities' with: 'Coral-Utilities-DamienPollet.3';
			package: 'Coral-IO' with: 'Coral-IO-CamilloBruni.6';
			package: 'Coral-Commandline' with: 'Coral-Commandline-DamienPollet.6';
			package: 'Coral-Tests' with: 'Coral-Tests-DamienPollet.2';
			package: 'Coral-Examples-Esug2011' with: 'Coral-Examples-Esug2011-DamienPollet.13'. ].
! !

!ConfigurationOfCoral methodsFor: 'versions' stamp: 'DamienPollet 3/1/2012 17:06'!
version02: spec
	<version: '0.2' imports: #('0.5-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: 'Progress:
- Include readline
- Depend on Readline packages, do not open workspaces when loading code
- Better option parsing in launcher shell script
- Depend on devel version of readline
- Make coral.sh more portable
- Fix class declaration syntax & tests touching system classes
- Fix getting parameters from CommandLine
- Print errors to stderr'.
		spec author: 'DamienPollet'.
		spec timestamp: '3/1/2012 17:06'.
		spec 
			project: 'OSProcess' with: '4.4.6';
			project: 'PetitParser' with: '1.4';
			project: 'Readline' with: '0.1'.
		spec 
			package: 'Coral-Core' with: 'Coral-Core-DamienPollet.13';
			package: 'Coral-Utilities' with: 'Coral-Utilities-LucFabresse.7';
			package: 'Coral-Commandline' with: 'Coral-Commandline-DamienPollet.7';
			package: 'Coral-Tests' with: 'Coral-Tests-DamienPollet.4';
			package: 'Coral-Examples-Esug2011' with: 'Coral-Examples-Esug2011-DamienPollet.13'. ].
! !
